Index: contrib/ntp/ntpq/ntpq.1ntpqmdoc
===================================================================
--- contrib/ntp/ntpq/ntpq.1ntpqmdoc	(revision 330566)
+++ contrib/ntp/ntpq/ntpq.1ntpqmdoc	(revision 330631)
@@ -683,98 +748,102 @@
 .Bl -tag -width "something" -compact -offset indent
 .It Variable
 Description
-.It Ic host
+.It Cm host
 Autokey host name for this host
-.It Ic ident
+.It Cm ident
 Autokey group name for this host
-.It Ic flags
+.It Cm flags
 host flags  (see Autokey specification)
-.It Ic digest
+.It Cm digest
 OpenSSL message digest algorithm
-.It Ic signature
+.It Cm signature
 OpenSSL digest/signature scheme
-.It Ic update
+.It Cm update
 NTP seconds at last signature update
-.It Ic cert
+.It Cm cert
 certificate subject, issuer and certificate flags
-.It Ic until
+.It Cm until
 NTP seconds when the certificate expires
 .El
 .Ss Peer Variables
 The following peer variables appear in the
-.Ic rv
+.Ic readlist
 billboard for each association.
 Not all variables are displayed in some configurations.
+.Pp
 .Bl -tag -width "something" -compact -offset indent
 .It Variable
 Description
-.It Ic associd
-association ID
-.It Ic status
+.It Cm associd
+association id
+.It Cm status
 .Lk decode.html#peer "peer status word"
-.It Ic srcadr
+.It Cm srcadr
 source (remote) IP address
-.It Ic srcport
+.It Cm srcport
 source (remote) port
-.It Ic dstadr
+.It Cm dstadr
 destination (local) IP address
-.It Ic dstport
+.It Cm dstport
 destination (local) port
-.It Ic leap
+.It Cm leap
 leap indicator (0\-3)
-.It Ic stratum
+.It Cm stratum
 stratum (0\-15)
-.It Ic precision
+.It Cm precision
 precision (log2 s)
-.It Ic rootdelay
+.It Cm rootdelay
 total roundtrip delay to the primary reference clock
-.It Ic rootdisp
+.It Cm rootdisp
 total root dispersion to the primary reference clock
-.It Ic refid
-reference ID or
+.It Cm refid
+reference id or
 .Lk decode.html#kiss "kiss code"
-.It Ic reftime
+.It Cm reftime
 reference time
-.It Ic reach
+.It Cm rec
+last packet received time
+.It Cm reach
 reach register (octal)
-.It Ic unreach
+.It Cm unreach
 unreach counter
-.It Ic hmode
+.It Cm hmode
 host mode (1\-6)
-.It Ic pmode
+.It Cm pmode
 peer mode (1\-5)
-.It Ic hpoll
+.It Cm hpoll
 host poll exponent (log2 s) (3\-17)
-.It Ic ppoll
+.It Cm ppoll
 peer poll exponent (log2 s) (3\-17)
-.It Ic headway
+.It Cm headway
 headway (see
 .Lk rate.html "Rate Management and the Kiss\-o'\-Death Packet" )
-.It Ic flash
+.It Cm flash
 .Lk decode.html#flash "flash status word"
-.It Ic offset
+.It Cm keyid
+symmetric key id
+.It Cm offset
 filter offset
-.It Ic delay
+.It Cm delay
 filter delay
-.It Ic dispersion
+.It Cm dispersion
 filter dispersion
-.It Ic jitter
+.It Cm jitter
 filter jitter
-.It Ic ident
-Autokey group name for this association
-.It Ic bias
+.It Cm bias
 unicast/broadcast bias
-.It Ic xleave
+.It Cm xleave
 interleave delay (see
 .Lk xleave.html "NTP Interleaved Modes" )
 .El
 The
-.Ic bias
+.Cm bias
 variable is calculated when the first broadcast packet is received
 after the calibration volley.
-It represents the offset of the broadcast subgraph relative to the unicast subgraph.
+It represents the offset of the broadcast subgraph relative to the
+unicast subgraph.
 The
-.Ic xleave
+.Cm xleave
 variable appears only for the interleaved symmetric and interleaved modes.
 It represents the internal queuing, buffering and transmission delays
 for the preceding packet.
@@ -784,71 +853,73 @@
 .Bl -tag -width "something" -compact -offset indent
 .It Variable
 Description
-.It Ic flags
+.It Cm flags
 peer flags (see Autokey specification)
-.It Ic host
+.It Cm host
 Autokey server name
-.It Ic flags
+.It Cm flags
 peer flags (see Autokey specification)
-.It Ic signature
+.It Cm signature
 OpenSSL digest/signature scheme
-.It Ic initsequence
-initial key ID
-.It Ic initkey
+.It Cm initsequence
+initial key id
+.It Cm initkey
 initial key index
-.It Ic timestamp
+.It Cm timestamp
 Autokey signature timestamp
+.It Cm ident
+Autokey group name for this association
 .El
 .Ss Clock Variables
 The following clock variables appear in the
-.Ic cv
+.Ic clocklist
 billboard for each association with a reference clock.
 Not all variables are displayed in some configurations.
 .Bl -tag -width "something" -compact -offset indent
 .It Variable
 Description
-.It Ic associd
-association ID
-.It Ic status
+.It Cm associd
+association id
+.It Cm status
 .Lk decode.html#clock "clock status word"
-.It Ic device
+.It Cm device
 device description
-.It Ic timecode
+.It Cm timecode
 ASCII time code string (specific to device)
-.It Ic poll
+.It Cm poll
 poll messages sent
-.It Ic noreply
+.It Cm noreply
 no reply
-.It Ic badformat
+.It Cm badformat
 bad format
-.It Ic baddata
+.It Cm baddata
 bad date or time
-.It Ic fudgetime1
+.It Cm fudgetime1
 fudge time 1
-.It Ic fudgetime2
+.It Cm fudgetime2
 fudge time 2
-.It Ic stratum
+.It Cm stratum
 driver stratum
-.It Ic refid
-driver reference ID
-.It Ic flags
+.It Cm refid
+driver reference id
+.It Cm flags
 driver flags
 .El
 .Sh "OPTIONS"
 .Bl -tag
 .It  Fl 4 , Fl \-ipv4 
-Force IPv4 DNS name resolution.
+Force IPv4 name resolution.
 This option must not appear in combination with any of the following options:
 ipv6.
 .sp
-Force DNS resolution of following host names on the command line
+Force resolution of following host names on the command line
 to the IPv4 namespace.
 .It  Fl 6 , Fl \-ipv6 
-Force IPv6 DNS name resolution.
+Force IPv6 name resolution.
 This option must not appear in combination with any of the following options:
 ipv4.
 .sp
-Force DNS resolution of following host names on the command line
+Force resolution of following host names on the command line
 to the IPv6 namespace.
 .It  Fl c Ar cmd , Fl \-command Ns = Ns Ar cmd 
 run a command and exit.
@@ -878,7 +949,7 @@
 numeric host addresses.
 .sp
 Output all host addresses in dotted\-quad numeric format rather than
-converting to the canonical host names. 
+converting to the canonical host names.
 .It  Fl \-old\-rv 
 Always output status line with readvar.
 .sp
Index: contrib/ntp/ntpd/ntp_peer.c
===================================================================
--- contrib/ntp/ntpd/ntp_peer.c	(revision 330566)
+++ contrib/ntp/ntpd/ntp_peer.c	(revision 330631)
@@ -117,7 +117,7 @@
 					      struct peer *, int);
 static struct peer *	findexistingpeer_addr(sockaddr_u *,
 					      struct peer *, int,
-					      u_char);
+					      u_char, int *);
 static void		free_peer(struct peer *, int);
 static void		getmorepeermem(void);
 static int		score(struct peer *);
@@ -203,17 +203,18 @@
 	sockaddr_u *	addr,
 	struct peer *	start_peer,
 	int		mode,
-	u_char		cast_flags
+	u_char		cast_flags,
+	int *		ip_count
 	)
 {
 	struct peer *peer;
 
-	DPRINTF(2, ("findexistingpeer_addr(%s, %s, %d, 0x%x)\n",
+	DPRINTF(2, ("findexistingpeer_addr(%s, %s, %d, 0x%x, %p)\n",
 		sptoa(addr),
 		(start_peer)
 		    ? sptoa(&start_peer->srcadr)
 		    : "NULL",
-		mode, (u_int)cast_flags));
+		mode, (u_int)cast_flags, ip_count));
 
 	/*
 	 * start_peer is included so we can locate instances of the
@@ -234,6 +235,11 @@
 		DPRINTF(3, ("%s %s %d %d 0x%x 0x%x ", sptoa(addr),
 			sptoa(&peer->srcadr), mode, peer->hmode,
 			(u_int)cast_flags, (u_int)peer->cast_flags));
+		if (ip_count) {
+			if (SOCK_EQ(addr, &peer->srcadr)) {
+				(*ip_count)++;
+			}
+		}
  		if ((-1 == mode || peer->hmode == mode ||
 		     ((MDF_BCLNT & peer->cast_flags) &&
 		      (MDF_BCLNT & cast_flags))) &&
@@ -258,7 +264,8 @@
 	const char *	hostname,
 	struct peer *	start_peer,
 	int		mode,
-	u_char		cast_flags
+	u_char		cast_flags,
+	int *		ip_count
 	)
 {
 	if (hostname != NULL)
@@ -266,7 +273,7 @@
 					     start_peer, mode);
 	else
 		return findexistingpeer_addr(addr, start_peer, mode,
-					     cast_flags);
+					     cast_flags, ip_count);
 }
 
 
@@ -561,6 +568,7 @@
 	sockaddr_u *	srcadr,
 	const char *	hostname,
 	endpt *		dstadr,
+	int		ippeerlimit,
 	u_char		hmode,
 	u_char		version,
 	u_char		minpoll,
@@ -611,7 +619,7 @@
 		flags |= FLAG_IBURST;
 	if ((MDF_ACAST | MDF_POOL) & cast_flags)
 		flags &= ~FLAG_PREEMPT;
-	return newpeer(srcadr, hostname, dstadr, hmode, version,
+	return newpeer(srcadr, hostname, dstadr, ippeerlimit, hmode, version,
 	    minpoll, maxpoll, flags, cast_flags, ttl, key, ident);
 }
 
@@ -753,6 +761,7 @@
 	sockaddr_u *	srcadr,
 	const char *	hostname,
 	endpt *		dstadr,
+	int		ippeerlimit,
 	u_char		hmode,
 	u_char		version,
 	u_char		minpoll,
@@ -766,7 +775,9 @@
 {
 	struct peer *	peer;
 	u_int		hash;
+	int		ip_count = 0;
 
+
 	DEBUG_REQUIRE(srcadr);
 
 #ifdef AUTOKEY
@@ -799,11 +810,11 @@
 	 */
 	if (dstadr != NULL) {
 		peer = findexistingpeer(srcadr, hostname, NULL, hmode,
-					cast_flags);
+					cast_flags, &ip_count);
 		while (peer != NULL) {
-			if (peer->dstadr == dstadr ||
-			    ((MDF_BCLNT & cast_flags) &&
-			     (MDF_BCLNT & peer->cast_flags)))
+			if (   peer->dstadr == dstadr
+			    || (   (MDF_BCLNT & cast_flags)
+				&& (MDF_BCLNT & peer->cast_flags)))
 				break;
 
 			if (dstadr == ANY_INTERFACE_CHOOSE(srcadr) &&
@@ -811,12 +822,12 @@
 				break;
 
 			peer = findexistingpeer(srcadr, hostname, peer,
-						hmode, cast_flags);
+						hmode, cast_flags, &ip_count);
 		}
 	} else {
 		/* no endpt address given */
 		peer = findexistingpeer(srcadr, hostname, NULL, hmode,
-					cast_flags);
+					cast_flags, &ip_count);
 	}
 
 	/*
@@ -833,6 +844,30 @@
 		return NULL;
 	}
 
+DPRINTF(1, ("newpeer(%s) found no existing and %d other associations\n",
+		(hostname)
+		    ? hostname
+		    : stoa(srcadr),
+		ip_count));
+
+	/* Check ippeerlimit wrt ip_count */
+	if (ippeerlimit > -1) {
+		if (ip_count + 1 > ippeerlimit) {
+			DPRINTF(2, ("newpeer(%s) denied - ippeerlimit %d\n",
+				(hostname)
+				    ? hostname
+				    : stoa(srcadr),
+				ippeerlimit));
+			return NULL;
+		}
+	} else {
+		DPRINTF(1, ("newpeer(%s) - ippeerlimit %d ignored\n",
+			(hostname)
+			    ? hostname
+			    : stoa(srcadr),
+			ippeerlimit));
+	}
+
 	/*
 	 * Allocate a new peer structure. Some dirt here, since some of
 	 * the initialization requires knowlege of our system state.
Index: contrib/ntp/ntpd/ntp_restrict.c
===================================================================
--- contrib/ntp/ntpd/ntp_restrict.c	(revision 330566)
+++ contrib/ntp/ntpd/ntp_restrict.c	(revision 330631)
@@ -86,6 +86,8 @@
 
 /*
  * Our default entries.
+ *
+ * We can make this cleaner with c99 support: see init_restrict().
  */
 static	restrict_u	restrict_def4;
 static	restrict_u	restrict_def6;
@@ -94,8 +96,9 @@
  * "restrict source ..." enabled knob and restriction bits.
  */
 static	int		restrict_source_enabled;
-static	u_short		restrict_source_flags;
+static	u_short		restrict_source_rflags;
 static	u_short		restrict_source_mflags;
+static	short		restrict_source_ippeerlimit;
 
 /*
  * private functions
@@ -111,9 +114,82 @@
 static restrict_u *	match_restrict_entry(const restrict_u *, int);
 static int		res_sorts_before4(restrict_u *, restrict_u *);
 static int		res_sorts_before6(restrict_u *, restrict_u *);
+static char *		roptoa(restrict_op op);
 
 
+void	dump_restricts(void);
+
 /*
+ * dump_restrict - spit out a restrict_u
+ */
+static void
+dump_restrict(
+	restrict_u *	res,
+	int		is_ipv6
+	)
+{
+	char as[INET6_ADDRSTRLEN];
+	char ms[INET6_ADDRSTRLEN];
+
+	if (is_ipv6) {
+		inet_ntop(AF_INET6, &res->u.v6.addr, as, sizeof as);
+		inet_ntop(AF_INET6, &res->u.v6.mask, ms, sizeof ms);
+	} else {
+		struct in_addr	sia = { htonl(res->u.v4.addr) };
+		struct in_addr	sim = { htonl(res->u.v4.mask) };
+
+		inet_ntop(AF_INET, &sia, as, sizeof as);
+		inet_ntop(AF_INET, &sim, ms, sizeof ms);
+	}
+	mprintf("restrict node at %p: %s/%s count %d, rflags %05x, mflags %05x, ippeerlimit %d, expire %lu, next %p\n",
+		res, as, ms, res->count, res->rflags, res->mflags,
+		res->ippeerlimit, res->expire, res->link);
+	return;
+}
+
+
+/*
+ * dump_restricts - spit out the 'restrict' lines
+ */
+void
+dump_restricts(void)
+{
+	int		defaultv4_done = 0;
+	int		defaultv6_done = 0;
+	restrict_u *	res;
+	restrict_u *	next;
+
+	mprintf("dump_restrict: restrict_def4: %p\n", &restrict_def4);
+	/* Spit out 'restrict {,-4,-6} default ...' lines, if needed */
+	for (res = &restrict_def4; res != NULL; res = next) {
+		dump_restrict(res, 0);
+		next = res->link;
+	}
+
+	mprintf("dump_restrict: restrict_def6: %p\n", &restrict_def6);
+	for (res = &restrict_def6; res != NULL; res = next) {
+		dump_restrict(res, 1);
+		next = res->link;
+	}
+
+	/* Spit out the IPv4 list */
+	mprintf("dump_restrict: restrictlist4: %p\n", &restrictlist4);
+	for (res = restrictlist4; res != NULL; res = next) {
+		dump_restrict(res, 0);
+		next = res->link;
+	}
+
+	/* Spit out the IPv6 list */
+	mprintf("dump_restrict: restrictlist6: %p\n", &restrictlist6);
+	for (res = restrictlist6; res != NULL; res = next) {
+		dump_restrict(res, 1);
+		next = res->link;
+	}
+
+	return;
+}
+
+/*
  * init_restrict - initialize the restriction data structures
  */
 void
@@ -147,6 +223,10 @@
 	 * behavior as but reversed implementation compared to the docs.
 	 * 
 	 */
+
+	restrict_def4.ippeerlimit = -1;		/* Cleaner if we have C99 */
+	restrict_def6.ippeerlimit = -1;		/* Cleaner if we have C99 */
+
 	LINK_SLIST(restrictlist4, &restrict_def4, link);
 	LINK_SLIST(restrictlist6, &restrict_def6, link);
 	restrictcount = 2;
@@ -215,7 +295,7 @@
 	restrict_u *	unlinked;
 
 	restrictcount--;
-	if (RES_LIMITED & res->flags)
+	if (RES_LIMITED & res->rflags)
 		dec_res_limited();
 
 	if (v6)
@@ -265,14 +345,21 @@
 	restrict_u *	next;
 
 	for (res = restrictlist4; res != NULL; res = next) {
+		struct in_addr	sia = { htonl(res->u.v4.addr) };
+
 		next = res->link;
-		if (res->expire &&
-		    res->expire <= current_time)
-			free_res(res, v6);
-		if (res->u.v4.addr == (addr & res->u.v4.mask)
-		    && (!(RESM_NTPONLY & res->mflags)
-			|| NTP_PORT == port))
+		DPRINTF(2, ("match_restrict4_addr: Checking %s, port %d ... ",
+			    inet_ntoa(sia), port));
+		if (   res->expire
+		    && res->expire <= current_time)
+			free_res(res, v6);	/* zeroes the contents */
+		if (   res->u.v4.addr == (addr & res->u.v4.mask)
+		    && (   !(RESM_NTPONLY & res->mflags)
+			|| NTP_PORT == port)) {
+			DPRINTF(2, ("MATCH: ippeerlimit %d\n", res->ippeerlimit));
 			break;
+		}
+		DPRINTF(2, ("doesn't match: ippeerlimit %d\n", res->ippeerlimit));
 	}
 	return res;
 }
@@ -410,19 +497,25 @@
 
 
 /*
- * restrictions - return restrictions for this host
+ * restrictions - return restrictions for this host in *r4a
  */
-u_short
+void
 restrictions(
-	sockaddr_u *srcadr
+	sockaddr_u *srcadr,
+	r4addr *r4a
 	)
 {
 	restrict_u *match;
 	struct in6_addr *pin6;
-	u_short flags;
 
+	REQUIRE(NULL != r4a);
+
 	res_calls++;
-	flags = 0;
+	r4a->rflags = RES_IGNORE;
+	r4a->ippeerlimit = 0;
+
+	DPRINTF(1, ("restrictions: looking up %s\n", stoa(srcadr)));
+
 	/* IPv4 source address */
 	if (IS_IPV4(srcadr)) {
 		/*
@@ -430,8 +523,11 @@
 		 * (this should be done early in the receive process,
 		 * not later!)
 		 */
-		if (IN_CLASSD(SRCADR(srcadr)))
-			return (int)RES_IGNORE;
+		if (IN_CLASSD(SRCADR(srcadr))) {
+			DPRINTF(1, ("restrictions: srcadr %s is multicast\n", stoa(srcadr)));
+			r4a->ippeerlimit = 2;	/* XXX: we should use a better value */
+			return;
+		}
 
 		match = match_restrict4_addr(SRCADR(srcadr),
 					     SRCPORT(srcadr));
@@ -448,7 +544,8 @@
 			res_not_found++;
 		else
 			res_found++;
-		flags = match->flags;
+		r4a->rflags = match->rflags;
+		r4a->ippeerlimit = match->ippeerlimit;
 	}
 
 	/* IPv6 source address */
@@ -461,7 +558,7 @@
 		 * not later!)
 		 */
 		if (IN6_IS_ADDR_MULTICAST(pin6))
-			return (int)RES_IGNORE;
+			return;
 
 		match = match_restrict6_addr(pin6, SRCPORT(srcadr));
 		INSIST(match != NULL);
@@ -470,22 +567,43 @@
 			res_not_found++;
 		else
 			res_found++;
-		flags = match->flags;
+		r4a->rflags = match->rflags;
+		r4a->ippeerlimit = match->ippeerlimit;
 	}
-	return (flags);
+	return;
 }
 
 
 /*
+ * roptoa - convert a restrict_op to a string
+ */
+char *
+roptoa(restrict_op op) {
+	static char sb[30];
+
+	switch(op) {
+	    case RESTRICT_FLAGS:	return "RESTRICT_FLAGS";
+	    case RESTRICT_UNFLAG:	return "RESTRICT_UNFLAGS";
+	    case RESTRICT_REMOVE:	return "RESTRICT_REMOVE";
+	    case RESTRICT_REMOVEIF:	return "RESTRICT_REMOVEIF";
+	    default:
+		snprintf(sb, sizeof sb, "**RESTRICT_#%d**", op);
+		return sb;
+	}
+}
+
+
+/*
  * hack_restrict - add/subtract/manipulate entries on the restrict list
  */
 void
 hack_restrict(
-	int		op,
+	restrict_op	op,
 	sockaddr_u *	resaddr,
 	sockaddr_u *	resmask,
+	short		ippeerlimit,
 	u_short		mflags,
-	u_short		flags,
+	u_short		rflags,
 	u_long		expire
 	)
 {
@@ -494,14 +612,15 @@
 	restrict_u *	res;
 	restrict_u **	plisthead;
 
-	DPRINTF(1, ("restrict: op %d addr %s mask %s mflags %08x flags %08x\n",
-		    op, stoa(resaddr), stoa(resmask), mflags, flags));
+	DPRINTF(1, ("hack_restrict: op %s addr %s mask %s ippeerlimit %d mflags %08x rflags %08x\n",
+		    roptoa(op), stoa(resaddr), stoa(resmask), ippeerlimit, mflags, rflags));
 
 	if (NULL == resaddr) {
 		REQUIRE(NULL == resmask);
 		REQUIRE(RESTRICT_FLAGS == op);
-		restrict_source_flags = flags;
+		restrict_source_rflags = rflags;
 		restrict_source_mflags = mflags;
+		restrict_source_ippeerlimit = ippeerlimit;
 		restrict_source_enabled = 1;
 		return;
 	}
@@ -538,8 +657,9 @@
 	} else	/* not IPv4 nor IPv6 */
 		REQUIRE(0);
 
-	match.flags = flags;
+	match.rflags = rflags;
 	match.mflags = mflags;
+	match.ippeerlimit = ippeerlimit;
 	match.expire = expire;
 	res = match_restrict_entry(&match, v6);
 
@@ -547,7 +667,7 @@
 
 	case RESTRICT_FLAGS:
 		/*
-		 * Here we add bits to the flags. If this is a
+		 * Here we add bits to the rflags. If this is a
 		 * new restriction add it.
 		 */
 		if (NULL == res) {
@@ -569,26 +689,29 @@
 				  : res_sorts_before4(res, L_S_S_CUR()),
 				link, restrict_u);
 			restrictcount++;
-			if (RES_LIMITED & flags)
+			if (RES_LIMITED & rflags)
 				inc_res_limited();
 		} else {
-			if ((RES_LIMITED & flags) &&
-			    !(RES_LIMITED & res->flags))
+			if (   (RES_LIMITED & rflags)
+			    && !(RES_LIMITED & res->rflags))
 				inc_res_limited();
-			res->flags |= flags;
+			res->rflags |= rflags;
 		}
+
+		res->ippeerlimit = match.ippeerlimit;
+
 		break;
 
 	case RESTRICT_UNFLAG:
 		/*
-		 * Remove some bits from the flags. If we didn't
+		 * Remove some bits from the rflags. If we didn't
 		 * find this one, just return.
 		 */
 		if (res != NULL) {
-			if ((RES_LIMITED & res->flags)
-			    && (RES_LIMITED & flags))
+			if (   (RES_LIMITED & res->rflags)
+			    && (RES_LIMITED & rflags))
 				dec_res_limited();
-			res->flags &= ~flags;
+			res->rflags &= ~rflags;
 		}
 		break;
 
@@ -639,7 +762,7 @@
 	SET_HOSTMASK(&onesmask, AF(addr));
 	if (farewell) {
 		hack_restrict(RESTRICT_REMOVE, addr, &onesmask,
-			      0, 0, 0);
+			      -2, 0, 0, 0);
 		DPRINTF(1, ("restrict_source: %s removed", stoa(addr)));
 		return;
 	}
@@ -672,8 +795,8 @@
 		return;
 
 	hack_restrict(RESTRICT_FLAGS, addr, &onesmask,
-		      restrict_source_mflags, restrict_source_flags,
-		      expire);
+		      restrict_source_ippeerlimit, restrict_source_mflags,
+		      restrict_source_rflags, expire);
 	DPRINTF(1, ("restrict_source: %s host restriction added\n", 
 		    stoa(addr)));
 }
Index: contrib/ntp/ntpd/ntpd-opts.h
===================================================================
--- contrib/ntp/ntpd/ntpd-opts.h	(revision 330566)
+++ contrib/ntp/ntpd/ntpd-opts.h	(revision 330631)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpd-opts.h)
  *
- *  It has been AutoGen-ed  March 21, 2017 at 10:42:11 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  February 27, 2018 at 05:13:17 PM by AutoGen 5.18.5
  *  From the definitions    ntpd-opts.def
  *  and the template file   options
  *
@@ -106,9 +106,9 @@
 /** count of all options for ntpd */
 #define OPTION_CT    38
 /** ntpd version */
-#define NTPD_VERSION       "4.2.8p10"
+#define NTPD_VERSION       "4.2.8p11"
 /** Full ntpd version text */
-#define NTPD_FULL_VERSION  "ntpd 4.2.8p10"
+#define NTPD_FULL_VERSION  "ntpd 4.2.8p11"
 
 /**
  *  Interface defines for all options.  Replace "n" with the UPPER_CASED
Index: contrib/ntp/ntpd/refclock_gpsdjson.c
===================================================================
--- contrib/ntp/ntpd/refclock_gpsdjson.c	(revision 330566)
+++ contrib/ntp/ntpd/refclock_gpsdjson.c	(revision 330631)
@@ -1891,7 +1891,7 @@
 	 */
 	ov = 1;
 	rc = setsockopt(up->fdt, IPPROTO_TCP, TCP_NODELAY,
-			(char*)&ov, sizeof(ov));
+			(void *)&ov, sizeof(ov));
 	if (-1 == rc) {
 		if (syslogok(pp, up))
 			msyslog(LOG_INFO,
@@ -1999,7 +1999,7 @@
 	/* check for socket error */
 	ec = 0;
 	lc = sizeof(ec);
-	rc = getsockopt(up->fdt, SOL_SOCKET, SO_ERROR, &ec, &lc);
+	rc = getsockopt(up->fdt, SOL_SOCKET, SO_ERROR, (void *)&ec, &lc);
 	if (-1 == rc || 0 != ec) {
 		const char *errtxt;
 		if (0 == ec)
Index: contrib/ntp/ntpdc/ntpdc-opts.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc-opts.c	(revision 330566)
+++ contrib/ntp/ntpdc/ntpdc-opts.c	(revision 330631)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.c)
  *
- *  It has been AutoGen-ed  March 21, 2017 at 10:44:44 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  February 27, 2018 at 05:14:56 PM by AutoGen 5.18.5
  *  From the definitions    ntpdc-opts.def
  *  and the template file   options
  *
@@ -69,7 +69,7 @@
  *  static const strings for ntpdc options
  */
 static char const ntpdc_opt_strs[1914] =
-/*     0 */ "ntpdc 4.2.8p10\n"
+/*     0 */ "ntpdc 4.2.8p11\n"
             "Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
@@ -128,7 +128,7 @@
 /*  1695 */ "no-load-opts\0"
 /*  1708 */ "no\0"
 /*  1711 */ "NTPDC\0"
-/*  1717 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p10\n"
+/*  1717 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p11\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n\0"
 /*  1848 */ "$HOME\0"
 /*  1854 */ ".\0"
@@ -135,7 +135,7 @@
 /*  1856 */ ".ntprc\0"
 /*  1863 */ "http://bugs.ntp.org, bugs@ntp.org\0"
 /*  1897 */ "\n\0"
-/*  1899 */ "ntpdc 4.2.8p10";
+/*  1899 */ "ntpdc 4.2.8p11";
 
 /**
  *  ipv4 option description with
@@ -796,7 +796,7 @@
      translate option names.
    */
   /* referenced via ntpdcOptions.pzCopyright */
-  puts(_("ntpdc 4.2.8p10\n\
+  puts(_("ntpdc 4.2.8p11\n\
 Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
@@ -862,7 +862,7 @@
   puts(_("load options from a config file"));
 
   /* referenced via ntpdcOptions.pzUsageTitle */
-  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p10\n\
+  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p11\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n"));
 
   /* referenced via ntpdcOptions.pzExplain */
@@ -869,7 +869,7 @@
   puts(_("\n"));
 
   /* referenced via ntpdcOptions.pzFullVersion */
-  puts(_("ntpdc 4.2.8p10"));
+  puts(_("ntpdc 4.2.8p11"));
 
   /* referenced via ntpdcOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: contrib/ntp/ntpdc/ntpdc.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc.c	(revision 330566)
+++ contrib/ntp/ntpdc/ntpdc.c	(revision 330631)
@@ -499,7 +499,7 @@
 		int optionValue = SO_SYNCHRONOUS_NONALERT;
 		int err;
 
-		err = setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (char *)&optionValue, sizeof(optionValue));
+		err = setsockopt(INVALID_SOCKET, SOL_SOCKET, SO_OPENTYPE, (void *)&optionValue, sizeof(optionValue));
 		if (err != NO_ERROR) {
 			(void) fprintf(stderr, "cannot open nonoverlapped sockets\n");
 			exit(1);
@@ -519,7 +519,7 @@
 		int rbufsize = INITDATASIZE + 2048; /* 2K for slop */
 
 		if (setsockopt(sockfd, SOL_SOCKET, SO_RCVBUF,
-			       &rbufsize, sizeof(int)) == -1)
+			       (void *)&rbufsize, sizeof(int)) == -1)
 		    error("setsockopt");
 	}
 # endif
Index: contrib/ntp/ntpdc/ntpdc_ops.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc_ops.c	(revision 330566)
+++ contrib/ntp/ntpdc/ntpdc_ops.c	(revision 330631)
@@ -1683,7 +1683,7 @@
 	const char *mask;
 	struct resflags *rf;
 	u_int32 count;
-	u_short flags;
+	u_short rflags;
 	u_short mflags;
 	char flagstr[300];
 	static const char *comma = ", ";
@@ -1730,7 +1730,7 @@
 		    ((pcmd->argval->ival == 4) && (rl->v6_flag == 0)))
 			skip = 0;
 		count = ntohl(rl->count);
-		flags = ntohs(rl->flags);
+		rflags = ntohs(rl->rflags);
 		mflags = ntohs(rl->mflags);
 		flagstr[0] = '\0';
 
@@ -1753,7 +1753,7 @@
 			 : &resflagsV3[0];
 
 		while (rf->bit != 0) {
-			if (flags & rf->bit) {
+			if (rflags & rf->bit) {
 				if (!res)
 					strlcat(flagstr, comma,
 						sizeof(flagstr));
